#!/usr/bin/env python

"""
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>

	This is version 0.0.2
"""

import pygame, sys, math

from pygame.locals import *

pygame.font.init()

WHITE=(255,255,255)
BLACK=(0,0,0)
GREEN=(0,255,0)
BLUE=(0,0,255)
RED=(255,0,0)

FPS = 30 # frames per second
WINDOWWIDTH = 640 # size of window's width
WINDOWHEIGHT = 480 # size of windows' height

fontObj = pygame.font.Font('freesansbold.ttf', 14)

FPSCLOCK = pygame.time.Clock()

class PeaFire(object):
    def __init__(self, remaining, screen):
        self.peasRemaining = remaining
        self.peasEscaped = 0
        PeaFire.SCREEN=screen
        
    def play(self):
        PeaFire.SCREEN.fill(BLACK)

        textSurfaceObj = fontObj.render("Peas Remaining: "+str(self.peasRemaining), True, GREEN, BLUE)
        textRectObj = textSurfaceObj.get_rect()
        textRectObj.topleft=(50,50)
        PeaFire.SCREEN.blit(textSurfaceObj, textRectObj)

        pygame.display.update()
        
        class pea(object):
            def __init__ (self, x, y, angle, speed):
                self.x = x
                self.y = y
                self.speedx = float(x/10) * speed 
                self.speedy = -(math.sqrt((100*100)-(x*x))/10) * speed 
                
            def update(self):
                self.speedx=self.speedx*0.99
                if self.speedy > -1:
                    if self.speedy < 0:
                        self.speedy = -self.speedy
                        self.speedy=1
                if self.speedy<0:
                    # going up
                    self.speedy=self.speedy*0.9
                else:
                    # going down
                    self.speedy=self.speedy*1.1
                self.x+=self.speedx
                self.y+=self.speedy
        
        class target(object):
            def __init__(self, x, width, direction):
                self.x = x
                self.width = width
                self.dir = direction
                
            def update(self):
                if self.dir == 'left':
                    self.x = self.x - 1
                    if self.x <= 0:
                        self.dir = 'right'
                else:
                    self.x = self.x + 1
                    if self.x >= WINDOWWIDTH-100:
                        self.dir = 'left'
        
        exit=False
        peas=[]
        angle=30
        power=10
        gun_x1=0
        gun_y1=480
        gun_x2=int(math.cos(math.radians(angle))*100)
        gun_y2=int(math.sin(math.radians(angle))*100)
        pygame.draw.line(PeaFire.SCREEN, WHITE, (gun_x1,gun_y1), (gun_x2, 480-gun_y2), 2)
        pygame.display.update()
        plates=[]
        plates.append(target (200, 100, 'left'))
        plates.append(target (400, 100, 'left'))
        plates.append(target (600, 100, 'left'))
        plates.append(target (100, 100, 'right'))
        plates.append(target (300, 100, 'right'))
        plates.append(target (500, 100, 'right'))
        peasremaining = self.peasRemaining
        escaped=0
        while exit==False: #main section loop
            update=[]

            for event in pygame.event.get(): # event handling loop
                if event.type == QUIT:
                    exit=True
                elif event.type==KEYDOWN:
                    if event.key == pygame.K_ESCAPE:
                        exit=True
                    elif event.key == pygame.K_p:
                        if peasremaining>0:
                            peas.append(pea(gun_x2, WINDOWHEIGHT-gun_y2, angle, 2.2))
                            peasremaining=peasremaining-1
                            
                            update.append(pygame.draw.rect(PeaFire.SCREEN, BLACK, (50, 50, WINDOWWIDTH, 25)))
                            textSurfaceObj = fontObj.render("Peas Remaining: "+str(peasremaining)+ " Rescued: "+str(escaped), True, GREEN, BLUE)
                            textRectObj = textSurfaceObj.get_rect()
                            textRectObj.topleft=(50,50)
                            update.append(PeaFire.SCREEN.blit(textSurfaceObj, textRectObj))
            
            for myTarget in plates:
                update.append(pygame.draw.line(PeaFire.SCREEN, BLACK, (myTarget.x+5, WINDOWHEIGHT-2), (myTarget.x+myTarget.width-5, WINDOWHEIGHT-2), 1))
                update.append(pygame.draw.line(PeaFire.SCREEN, BLACK, (myTarget.x, WINDOWHEIGHT-7), (myTarget.x+myTarget.width, WINDOWHEIGHT-7), 1))

                update.append(pygame.draw.line(PeaFire.SCREEN, BLACK, (myTarget.x+myTarget.width-5, WINDOWHEIGHT-2), (myTarget.x+myTarget.width, WINDOWHEIGHT-7), 1))
                update.append(pygame.draw.line(PeaFire.SCREEN, BLACK, (myTarget.x+5, WINDOWHEIGHT-2), (myTarget.x, WINDOWHEIGHT-7), 1))

                myTarget.update()

                update.append(pygame.draw.line(PeaFire.SCREEN, BLUE, (myTarget.x+5, WINDOWHEIGHT-2), (myTarget.x+myTarget.width-5, WINDOWHEIGHT-2), 1))
                update.append(pygame.draw.line(PeaFire.SCREEN, BLUE, (myTarget.x, WINDOWHEIGHT-7), (myTarget.x+myTarget.width, WINDOWHEIGHT-7), 1))
        
                update.append(pygame.draw.line(PeaFire.SCREEN, BLUE, (myTarget.x+myTarget.width-5, WINDOWHEIGHT-2), (myTarget.x+myTarget.width, WINDOWHEIGHT-7), 1))
                update.append(pygame.draw.line(PeaFire.SCREEN, BLUE, (myTarget.x+5, WINDOWHEIGHT-2), (myTarget.x, WINDOWHEIGHT-7), 1))

            for p in peas:
                update.append(pygame.draw.circle(PeaFire.SCREEN, BLACK, (int(p.x), int(p.y)), 3))
                p.update()
                if p.y>480:
                    peas.remove(p)
                    hitPlate = False
                    for myTarget in plates:
                        if p.x>=myTarget.x:
                            if p.x<=myTarget.x+myTarget.width:
                                hitPlate = True
                    if hitPlate == False:
                        escaped=escaped+1
                elif p.x>WINDOWWIDTH:
                    update.append(pygame.draw.line(PeaFire.SCREEN, GREEN, (WINDOWWIDTH-1, p.y+5), (WINDOWWIDTH-1, p.y-5)))
                    peas.remove(p)
                else:
                    update.append(pygame.draw.circle(PeaFire.SCREEN, GREEN, (int(p.x), int(p.y)), 3))
            
            keys=pygame.key.get_pressed()
            if keys[pygame.K_z]:
                moved=True
                angle=angle-1
                if angle<=10:
                    angle=10
            elif keys[pygame.K_a]:
                moved=True
                angle=angle+1
                if angle>=80:
                    angle=80
            else:
                moved=False
        
            if moved==True:
                update.append(pygame.draw.line(PeaFire.SCREEN, BLACK, (gun_x1,gun_y1), (gun_x2, WINDOWHEIGHT-gun_y2), 2));
                gun_x2=int(math.cos(math.radians(angle))*100)
                gun_y2=int(math.sin(math.radians(angle))*100)
                update.append(pygame.draw.line(PeaFire.SCREEN, WHITE, (gun_x1,gun_y1), (gun_x2, WINDOWHEIGHT-gun_y2), 2));
            
            pygame.display.update(update)
            
            if len(peas)==0:
                if peasremaining==0:
                    exit=True
            
            FPSCLOCK.tick(FPS)
            
        self.peasEscaped = escaped
