#!/usr/bin/env python

"""
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>

	This is version 0.0.2
	See bottom of source for changelog
"""

"""
    One Way Trip
"""

import pygame, sys, math

from peafire import PeaFire

from pygame.locals import *

FPS = 30 # frames per second
WINDOWWIDTH = 640 # size of window's width
WINDOWHEIGHT = 480 # size of windows' height

GREEN=(0,255,0)
BLUE=(0,0,255)
WHITE=(255,255,255)

pygame.init()

SCREEN = pygame.display.set_mode((WINDOWWIDTH, WINDOWHEIGHT))
#SCREEN = pygame.display.set_mode((WINDOWWIDTH, WINDOWHEIGHT), FULLSCREEN|HWSURFACE|DOUBLEBUF)
pygame.display.set_caption ("Escape Peas")

fontObj = pygame.font.Font('freesansbold.ttf', 14)

myPeas = 25

textSurfaceObj = fontObj.render("The peas have escaped from the freezer, now they must", True, WHITE, BLUE)
textRectObj = textSurfaceObj.get_rect()
textRectObj.topleft=(50,50)
SCREEN.blit(textSurfaceObj, textRectObj)
textSurfaceObj = fontObj.render("get out of the house!", True, WHITE, BLUE)
textRectObj = textSurfaceObj.get_rect()
textRectObj.topleft=(50,100)
SCREEN.blit(textSurfaceObj, textRectObj)

textSurfaceObj = fontObj.render("The idea of this game is to help the peas escape", True, GREEN, BLUE)
textRectObj = textSurfaceObj.get_rect()
textRectObj.topleft=(50,250)
SCREEN.blit(textSurfaceObj, textRectObj)
textSurfaceObj = fontObj.render("You need to fire them with the\nA and Z button to aim and P to fire.", True, GREEN, BLUE)
textRectObj = textSurfaceObj.get_rect()
textRectObj.topleft=(50,300)
SCREEN.blit(textSurfaceObj, textRectObj)
textSurfaceObj = fontObj.render("Make sure you don't hit a dinner plate or hit the wall at the end.", True, GREEN, BLUE)
textRectObj = textSurfaceObj.get_rect()
textRectObj.topleft=(50,350)
SCREEN.blit(textSurfaceObj, textRectObj)
textSurfaceObj = fontObj.render("Press P to begin.", True, GREEN, BLUE)
textRectObj = textSurfaceObj.get_rect()
textRectObj.topleft=(50,400)
SCREEN.blit(textSurfaceObj, textRectObj)
pygame.display.update()
exit=False
while exit==False:
    for event in pygame.event.get():
        if event.type == QUIT:
            exit=True
        elif event.type==KEYDOWN:
            if event.key == pygame.K_p:
                exit=True

miniGame = PeaFire(myPeas, SCREEN)
miniGame.play()
myPeas = miniGame.peasEscaped

textSurfaceObj = fontObj.render("You saved "+str(myPeas)+" peas. Press any key to exit.", True, GREEN, BLUE)
textRectObj = textSurfaceObj.get_rect()
textRectObj.topleft=(50,200)
SCREEN.blit(textSurfaceObj, textRectObj)
pygame.display.update()
exit=False
while exit==False:
    for event in pygame.event.get():
        if event.type == QUIT:
            exit=True
        elif event.type==KEYDOWN:
            exit=True

pygame.quit()
sys.exit()

"""
	Changelog

	2012-09-15
	version 0.0.1
	Improved plates
	Changed the allowed angle so you can't just fire straight up!
	Added basic instructions 
	Added score at the end

	2012-09-15
	version 0.0.1
	Initial Release

"""
